# -*- coding: utf-8 -*-
"""
Created on Thu Apr 12 10:20:04 2018

@author: Administrator
"""
import re
import csv
import xlwt
#读取虚词列表------Read stop word list

def readUselessWord(filePath):
    f = open(filePath)
    txt = f.read()
    tingyongci = txt.split(",")
    tingyongci=list(set(tingyongci))
    return tingyongci

#把csv文件内容一行一行读取，去虚词-----Read CSV files from line to line,remove of function words

def cutFileIntoList(uselessWordPath,csvPath):
    app=[] #定义空的列表
    uselessWordList=readUselessWord(uselessWordPath) #调用读虚词的函数，将结果返回到uselessWordList
    csvfile = open(csvPath, 'r')
    
    for line in csvfile: #以下for循环内的操作是对csv文件中每一行数据
        #data.append(list(line.strip().split(',')))
        oneRowSplitWords=str(line.strip())#一行数据的三个属性的全部分词-----A piece of document data inclue a paper's title,abstract,keywords
        #print(oneRowSplitWords)    
        
        #oneRowSplitWords=oneRowSplitWords.replace(', ',',') #将Blaner, W. S.转换为Blaner,W.S.就是去掉名字中逗号和点号后的空格
        #oneRowSplitWords=oneRowSplitWords.replace('. ','.') #
      
        
        oneRowSplitWords=re.sub('()[\"*\']','',oneRowSplitWords)
        
        print(oneRowSplitWords)
        #oneRowSplitWords=oneRowSplitWords.replace('(',' ')
        #oneRowSplitWords=oneRowSplitWords.replace(')',' ')
        #print(new_oneRowSplitWords)
        oneRowSplitWords=oneRowSplitWords.split('; ')
        #print(new_oneRowSplitWords)
        for i in range(len(oneRowSplitWords)-1, -1, -1): #创建整数列表，长度为每行字符串的个数
            #print ("number：%s   value：%s" % (i + 1, list[i]))
            if oneRowSplitWords[i] in uselessWordList: #判断某一字符串是否在停用词列表中
                oneRowSplitWords.pop(i)
        #print(oneRowSplitWords)#每一个记录分好词-----document segmentation
        app.append(oneRowSplitWords)
    return app

#词，词频统计，在三个里面出现一次，算1-----word frequency count.
def statWordFreq(app):
    word_counts={} #定义一个字典对象
    for ap in app: 
        ap=list(set(ap))#一条记录中出现多次只算一次------If a word appears many times in headings, abstracts, and keywords, count them once. 
        for a in ap:
            if a in word_counts:
                word_counts[a]=word_counts[a]+1
            else:
                word_counts[a]=1
    '''      
    key_list=list(word_counts.keys())
    key_list.sort()
    for key in key_list:
        if word_counts[key]>=1:
            print("{}:{}".format(key,word_counts[key]))
    '''
    return word_counts

def saveWordFreq(word_counts,wordFreqfilePath):
    print("写入文件")
    with open(wordFreqfilePath, "w",newline='') as csvFile:
        csvWriter = csv.writer(csvFile)
        for k,v in word_counts.items():
            csvWriter.writerow([k,v])
        csvFile.close()
    print("写入完毕")
    
def main():
    #存放虚词的文件-----Function word File
    uselessWordPath='tingyongci.txt'
    #存放由excel另存的csv文件-----CSV File
    csvPath='test.csv'
    apps = cutFileIntoList(uselessWordPath,csvPath)
    word_counts=statWordFreq(apps)
    #词频统计结果文件-----The result of word Frequency File
    wordFreqfilePath='testtest_freq.csv'
    saveWordFreq(word_counts,wordFreqfilePath)
    #for row in tables:
       #print(row)
if __name__ =="__main__":
    main()

    

        